From e835a66c76a3eb897ca018dc59a1e2792d54db98 Mon Sep 17 00:00:00 2001
From: Robert Lin <robert@bobheadxi.dev>
Date: Tue, 19 Sep 2023 22:20:15 -0700
Subject: [PATCH] telemetrygateway: add exporter and service (#56699)

This change adds:

- telemetry export background jobs: flagged behind `TELEMETRY_GATEWAY_EXPORTER_EXPORT_ADDR`, default empty => disabled
- telemetry redaction: configured in package `internal/telemetry/sensitivemetadataallowlist`
- telemetry-gateway service receiving events and forwarding it to a pub/sub topic (or just logging it, as configured in local dev)
- utilities for easily creating an event recorder: `internal/telemetry/telemetryrecorder`
Notes:

- all changes are feature-flagged to some degree, off by default, so the merge should be fairly low-risk.
- we decided that transmitting the full license key continues to be the way to go. we transmit it once per stream and attach it on all events in the telemetry-gateway. there is no auth mechanism at the moment
- GraphQL return type `EventLog.Source` is now a plain string instead of string enum. This should not be a breaking change in our clients, but must be made so that our generated V2 events do not break requesting of event logs

Stacked on https://github.com/sourcegraph/sourcegraph/pull/56520

Closes https://github.com/sourcegraph/sourcegraph/issues/56289
Closes https://github.com/sourcegraph/sourcegraph/issues/56287

## Test plan

Add an override to make the export super frequent:

```
env:
  TELEMETRY_GATEWAY_EXPORTER_EXPORT_INTERVAL: "10s"
  TELEMETRY_GATEWAY_EXPORTER_EXPORTED_EVENTS_RETENTION: "5m"
```

Start sourcegraph:

```
sg start
```

Enable `telemetry-export` featureflag (from https://github.com/sourcegraph/sourcegraph/pull/56520)

Emit some events in GraphQL:

```gql
mutation {
  telemetry {
    recordEvents(events:[{
      feature:"foobar"
      action:"view"
      source:{
        client:"WEB"
      }
      parameters:{
        version:0
      }
    }]) {
      alwaysNil
    }
  }
```

See series of log events:

```
[         worker] INFO worker.telemetrygateway-exporter telemetrygatewayexporter/telemetrygatewayexporter.go:61 Telemetry Gateway export enabled - initializing background routines
[         worker] INFO worker.telemetrygateway-exporter telemetrygatewayexporter/exporter.go:99 exporting events {"maxBatchSize": 10000, "count": 1}
[telemetry-g...y] INFO telemetry-gateway.pubsub pubsub/topic.go:115 Publish {"TraceId": "7852903434f0d2f647d397ee83b4009b", "SpanId": "8d945234bccf319b", "message": "{\"event\":{\"id\":\"dc96ae84-4ac4-4760-968f-0a0307b8bb3d\",\"timestamp\":\"2023-09-19T01:57:13.590266Z\",\"feature\":\"foobar\", ....
```

Build:

```
export VERSION="insiders"
bazel run //cmd/telemetry-gateway:candidate_push --config darwin-docker --stamp --workspace_status_command=./dev/bazel_stamp_vars.sh -- --tag $VERSION --repository us.gcr.io/sourcegraph-dev/telemetry-gateway
```

Deploy: https://github.com/sourcegraph/managed-services/pull/7

Add override:

```yaml
env:
  # Port required. TODO: What's the best way to provide gRPC addresses, such that a
  # localhost address is also possible?
  TELEMETRY_GATEWAY_EXPORTER_EXPORT_ADDR: "https://telemetry-gateway.sgdev.org:443"
```

Repeat the above (`sg start` and emit some events):

```
[         worker] INFO worker.telemetrygateway-exporter telemetrygatewayexporter/exporter.go:94 exporting events {"maxBatchSize": 10000, "count": 6}
[         worker] INFO worker.telemetrygateway-exporter telemetrygatewayexporter/exporter.go:113 events exported {"maxBatchSize": 10000, "succeeded": 6}
[         worker] INFO worker.telemetrygateway-exporter telemetrygatewayexporter/exporter.go:94 exporting events {"maxBatchSize": 10000, "count": 1}
[         worker] INFO worker.telemetrygateway-exporter telemetrygatewayexporter/exporter.go:113 events exported {"maxBatchSize": 10000, "succeeded": 1}
```
---
 .../productsubscription.go                    |   2 +-
 cmd/cody-gateway/internal/auth/BUILD.bazel    |   7 +-
 cmd/cody-gateway/internal/auth/auth.go        |   3 +-
 cmd/cody-gateway/internal/auth/auth_test.go   |   3 +-
 cmd/cody-gateway/internal/httpapi/BUILD.bazel |   1 +
 .../internal/httpapi/diagnostics.go           |   4 +-
 cmd/frontend/graphqlbackend/schema.graphql    |   2 +-
 .../productsubscription/tokens_graphql.go     |   4 +-
 .../internal/telemetry/resolvers/resolvers.go |   2 +-
 cmd/telemetry-gateway/BUILD.bazel             |  72 +++++++
 cmd/telemetry-gateway/CODENOTIFY              |   3 +
 cmd/telemetry-gateway/image_test.yaml         |  15 ++
 .../internal/diagnosticsserver/BUILD.bazel    |  14 ++
 .../diagnosticsserver/diagnosticsserver.go    |  71 +++++++
 .../internal/events/BUILD.bazel               |  15 ++
 .../internal/events/events.go                 |  77 ++++++++
 .../internal/server/BUILD.bazel               |  39 ++++
 .../internal/server/metrics.go                |  46 +++++
 .../internal/server/publish_events.go         | 113 +++++++++++
 .../internal/server/publish_events_test.go    |  60 ++++++
 .../internal/server/server.go                 | 138 ++++++++++++++
 cmd/telemetry-gateway/main.go                 |  33 ++++
 cmd/telemetry-gateway/shared/BUILD.bazel      |  43 +++++
 cmd/telemetry-gateway/shared/config.go        |  54 ++++++
 cmd/telemetry-gateway/shared/main.go          | 133 +++++++++++++
 cmd/telemetry-gateway/shared/metrics.go       |  58 ++++++
 cmd/telemetry-gateway/shared/service.go       |  31 ++++
 cmd/telemetry-gateway/shared/tracing.go       |  77 ++++++++
 dev/prometheus/all/prometheus_targets.yml     |   5 +
 dev/prometheus/linux/prometheus_targets.yml   |   5 +
 .../background-information/sg/reference.md    |   1 +
 doc/dev/how-to/index.md                       |   4 +
 doc/dev/how-to/telemetry_gateway.md           |  13 ++
 .../telemetrygatewayexporter/BUILD.bazel      |  28 +++
 .../backlog_metrics.go                        |  48 +++++
 .../telemetrygatewayexporter/exporter.go      | 114 ++++++++++++
 .../telemetrygatewayexporter/queue_cleanup.go |  50 +++++
 .../telemetrygatewayexporter.go               | 100 ++++++++++
 enterprise/cmd/worker/shared/BUILD.bazel      |   1 +
 enterprise/cmd/worker/shared/shared.go        |   2 +
 internal/authbearer/BUILD.bazel               |   9 +
 .../authbearer/authbearer.go                  |   2 +-
 internal/codygateway/consts.go                |   4 -
 internal/database/BUILD.bazel                 |   1 +
 internal/database/telemetry_export_store.go   |  31 +++-
 .../database/telemetry_export_store_test.go   |  20 +-
 internal/grpc/defaults/BUILD.bazel            |   1 +
 internal/grpc/defaults/defaults.go            |  26 ++-
 internal/productsubscription/consts.go        |   4 +
 internal/pubsub/BUILD.bazel                   |   2 +
 internal/pubsub/topic.go                      |  25 +++
 internal/telemetry/BUILD.bazel                |   4 +-
 internal/telemetry/besteffort.go              |  33 ++++
 internal/telemetry/events.go                  |   7 +
 .../sensitivemetadataallowlist/BUILD.bazel    |  35 ++++
 .../sensitivemetadataallowlist/redact.go      |  37 ++++
 .../sensitivemetadataallowlist/redact_test.go |  79 ++++++++
 .../sensitivemetadataallowlist_test.go        |  24 +++
 .../sensitiviemetadataallowlist.go            |  87 +++++++++
 internal/telemetry/teestore/BUILD.bazel       |   6 +-
 internal/telemetry/teestore/option.go         |  21 +++
 internal/telemetry/teestore/teestore.go       |  43 +++--
 internal/telemetry/teestore/teestore_test.go  |  11 +-
 internal/telemetry/telemetry.go               |  23 ++-
 internal/telemetry/telemetry_test.go          |  13 ++
 .../telemetry/telemetryrecorder/BUILD.bazel   |  14 ++
 .../telemetryrecorder/telemetryrecorder.go    |  34 ++++
 internal/telemetrygateway/BUILD.bazel         |  24 +++
 internal/telemetrygateway/exporter.go         | 175 ++++++++++++++++++
 internal/telemetrygateway/identifier.go       |  23 +++
 internal/telemetrygateway/v1/BUILD.bazel      |   4 +
 lib/pointers/ptr.go                           |   2 +-
 sg.config.yaml                                |  29 +++
 73 files changed, 2275 insertions(+), 69 deletions(-)
 create mode 100644 cmd/telemetry-gateway/BUILD.bazel
 create mode 100644 cmd/telemetry-gateway/CODENOTIFY
 create mode 100644 cmd/telemetry-gateway/image_test.yaml
 create mode 100644 cmd/telemetry-gateway/internal/diagnosticsserver/BUILD.bazel
 create mode 100644 cmd/telemetry-gateway/internal/diagnosticsserver/diagnosticsserver.go
 create mode 100644 cmd/telemetry-gateway/internal/events/BUILD.bazel
 create mode 100644 cmd/telemetry-gateway/internal/events/events.go
 create mode 100644 cmd/telemetry-gateway/internal/server/BUILD.bazel
 create mode 100644 cmd/telemetry-gateway/internal/server/metrics.go
 create mode 100644 cmd/telemetry-gateway/internal/server/publish_events.go
 create mode 100644 cmd/telemetry-gateway/internal/server/publish_events_test.go
 create mode 100644 cmd/telemetry-gateway/internal/server/server.go
 create mode 100644 cmd/telemetry-gateway/main.go
 create mode 100644 cmd/telemetry-gateway/shared/BUILD.bazel
 create mode 100644 cmd/telemetry-gateway/shared/config.go
 create mode 100644 cmd/telemetry-gateway/shared/main.go
 create mode 100644 cmd/telemetry-gateway/shared/metrics.go
 create mode 100644 cmd/telemetry-gateway/shared/service.go
 create mode 100644 cmd/telemetry-gateway/shared/tracing.go
 create mode 100644 doc/dev/how-to/telemetry_gateway.md
 create mode 100644 enterprise/cmd/worker/internal/telemetrygatewayexporter/BUILD.bazel
 create mode 100644 enterprise/cmd/worker/internal/telemetrygatewayexporter/backlog_metrics.go
 create mode 100644 enterprise/cmd/worker/internal/telemetrygatewayexporter/exporter.go
 create mode 100644 enterprise/cmd/worker/internal/telemetrygatewayexporter/queue_cleanup.go
 create mode 100644 enterprise/cmd/worker/internal/telemetrygatewayexporter/telemetrygatewayexporter.go
 create mode 100644 internal/authbearer/BUILD.bazel
 rename cmd/cody-gateway/internal/auth/bearer.go => internal/authbearer/authbearer.go (96%)
 create mode 100644 internal/telemetry/besteffort.go
 create mode 100644 internal/telemetry/sensitivemetadataallowlist/BUILD.bazel
 create mode 100644 internal/telemetry/sensitivemetadataallowlist/redact.go
 create mode 100644 internal/telemetry/sensitivemetadataallowlist/redact_test.go
 create mode 100644 internal/telemetry/sensitivemetadataallowlist/sensitivemetadataallowlist_test.go
 create mode 100644 internal/telemetry/sensitivemetadataallowlist/sensitiviemetadataallowlist.go
 create mode 100644 internal/telemetry/teestore/option.go
 create mode 100644 internal/telemetry/telemetryrecorder/BUILD.bazel
 create mode 100644 internal/telemetry/telemetryrecorder/telemetryrecorder.go
 create mode 100644 internal/telemetrygateway/exporter.go
 create mode 100644 internal/telemetrygateway/identifier.go

diff --git a/cmd/cody-gateway/internal/actor/productsubscription/productsubscription.go b/cmd/cody-gateway/internal/actor/productsubscription/productsubscription.go
index 64e04e4ea93..856610dce19 100644
--- a/cmd/cody-gateway/internal/actor/productsubscription/productsubscription.go
+++ b/cmd/cody-gateway/internal/actor/productsubscription/productsubscription.go
@@ -177,7 +177,7 @@ func (s *Source) checkAccessToken(ctx context.Context, token string) (*dotcom.Ch
 	}
 
 	for _, gqlerr := range gqlerrs {
-		if gqlerr.Extensions != nil && gqlerr.Extensions["code"] == codygateway.GQLErrCodeProductSubscriptionNotFound {
+		if gqlerr.Extensions != nil && gqlerr.Extensions["code"] == productsubscription.GQLErrCodeProductSubscriptionNotFound {
 			return nil, actor.ErrAccessTokenDenied{
 				Source: s.Name(),
 				Reason: "associated product subscription not found",
diff --git a/cmd/cody-gateway/internal/auth/BUILD.bazel b/cmd/cody-gateway/internal/auth/BUILD.bazel
index dd2b1c822df..8b6ed66b20e 100644
--- a/cmd/cody-gateway/internal/auth/BUILD.bazel
+++ b/cmd/cody-gateway/internal/auth/BUILD.bazel
@@ -3,16 +3,14 @@ load("@io_bazel_rules_go//go:def.bzl", "go_library")
 
 go_library(
     name = "auth",
-    srcs = [
-        "auth.go",
-        "bearer.go",
-    ],
+    srcs = ["auth.go"],
     importpath = "github.com/sourcegraph/sourcegraph/cmd/cody-gateway/internal/auth",
     visibility = ["//cmd/cody-gateway:__subpackages__"],
     deps = [
         "//cmd/cody-gateway/internal/actor",
         "//cmd/cody-gateway/internal/events",
         "//cmd/cody-gateway/internal/response",
+        "//internal/authbearer",
         "//internal/codygateway",
         "//internal/trace",
         "//lib/errors",
@@ -35,6 +33,7 @@ go_test(
         "//cmd/cody-gateway/internal/events",
         "//internal/codygateway",
         "//internal/licensing",
+        "//internal/productsubscription",
         "//lib/errors",
         "@com_github_derision_test_go_mockgen//testutil/require",
         "@com_github_gregjones_httpcache//:httpcache",
diff --git a/cmd/cody-gateway/internal/auth/auth.go b/cmd/cody-gateway/internal/auth/auth.go
index 99c5467ca96..cf5f45b4ae4 100644
--- a/cmd/cody-gateway/internal/auth/auth.go
+++ b/cmd/cody-gateway/internal/auth/auth.go
@@ -8,6 +8,7 @@ import (
 	"github.com/sourcegraph/sourcegraph/cmd/cody-gateway/internal/actor"
 	"github.com/sourcegraph/sourcegraph/cmd/cody-gateway/internal/events"
 	"github.com/sourcegraph/sourcegraph/cmd/cody-gateway/internal/response"
+	"github.com/sourcegraph/sourcegraph/internal/authbearer"
 	"github.com/sourcegraph/sourcegraph/internal/codygateway"
 	"github.com/sourcegraph/sourcegraph/internal/trace"
 	"github.com/sourcegraph/sourcegraph/lib/errors"
@@ -22,7 +23,7 @@ type Authenticator struct {
 func (a *Authenticator) Middleware(next http.Handler) http.Handler {
 	return http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
 		logger := trace.Logger(r.Context(), a.Logger)
-		token, err := ExtractBearer(r.Header)
+		token, err := authbearer.ExtractBearer(r.Header)
 		if err != nil {
 			response.JSONError(logger, w, http.StatusBadRequest, err)
 			return
diff --git a/cmd/cody-gateway/internal/auth/auth_test.go b/cmd/cody-gateway/internal/auth/auth_test.go
index 914a3af76aa..550aefd17ff 100644
--- a/cmd/cody-gateway/internal/auth/auth_test.go
+++ b/cmd/cody-gateway/internal/auth/auth_test.go
@@ -22,6 +22,7 @@ import (
 	"github.com/sourcegraph/sourcegraph/cmd/cody-gateway/internal/events"
 	"github.com/sourcegraph/sourcegraph/internal/codygateway"
 	"github.com/sourcegraph/sourcegraph/internal/licensing"
+	internalproductsubscription "github.com/sourcegraph/sourcegraph/internal/productsubscription"
 	"github.com/sourcegraph/sourcegraph/lib/errors"
 )
 
@@ -153,7 +154,7 @@ func TestAuthenticatorMiddleware(t *testing.T) {
 			return gqlerror.List{
 				{
 					Message:    "access denied",
-					Extensions: map[string]any{"code": codygateway.GQLErrCodeProductSubscriptionNotFound},
+					Extensions: map[string]any{"code": internalproductsubscription.GQLErrCodeProductSubscriptionNotFound},
 				},
 			}
 		})
diff --git a/cmd/cody-gateway/internal/httpapi/BUILD.bazel b/cmd/cody-gateway/internal/httpapi/BUILD.bazel
index e1734c96729..44144c48fec 100644
--- a/cmd/cody-gateway/internal/httpapi/BUILD.bazel
+++ b/cmd/cody-gateway/internal/httpapi/BUILD.bazel
@@ -19,6 +19,7 @@ go_library(
         "//cmd/cody-gateway/internal/limiter",
         "//cmd/cody-gateway/internal/notify",
         "//cmd/cody-gateway/internal/response",
+        "//internal/authbearer",
         "//internal/httpcli",
         "//internal/instrumentation",
         "//internal/redispool",
diff --git a/cmd/cody-gateway/internal/httpapi/diagnostics.go b/cmd/cody-gateway/internal/httpapi/diagnostics.go
index de3448ebf9c..0e2ae5d790d 100644
--- a/cmd/cody-gateway/internal/httpapi/diagnostics.go
+++ b/cmd/cody-gateway/internal/httpapi/diagnostics.go
@@ -12,9 +12,9 @@ import (
 	"go.opentelemetry.io/contrib/instrumentation/net/http/otelhttp"
 
 	"github.com/sourcegraph/sourcegraph/cmd/cody-gateway/internal/actor"
-	"github.com/sourcegraph/sourcegraph/cmd/cody-gateway/internal/auth"
 	"github.com/sourcegraph/sourcegraph/cmd/cody-gateway/internal/httpapi/requestlogger"
 	"github.com/sourcegraph/sourcegraph/cmd/cody-gateway/internal/response"
+	"github.com/sourcegraph/sourcegraph/internal/authbearer"
 	"github.com/sourcegraph/sourcegraph/internal/instrumentation"
 	"github.com/sourcegraph/sourcegraph/internal/redispool"
 	sgtrace "github.com/sourcegraph/sourcegraph/internal/trace"
@@ -30,7 +30,7 @@ func NewDiagnosticsHandler(baseLogger log.Logger, next http.Handler, secret stri
 	baseLogger = baseLogger.Scoped("diagnostics", "healthz checks")
 
 	hasValidSecret := func(l log.Logger, w http.ResponseWriter, r *http.Request) (yes bool) {
-		token, err := auth.ExtractBearer(r.Header)
+		token, err := authbearer.ExtractBearer(r.Header)
 		if err != nil {
 			response.JSONError(l, w, http.StatusBadRequest, err)
 			return false
diff --git a/cmd/frontend/graphqlbackend/schema.graphql b/cmd/frontend/graphqlbackend/schema.graphql
index 7aec98178e7..6349184ac55 100755
--- a/cmd/frontend/graphqlbackend/schema.graphql
+++ b/cmd/frontend/graphqlbackend/schema.graphql
@@ -8791,7 +8791,7 @@ type EventLog {
     """
     The source of the event.
     """
-    source: EventSource!
+    source: String!
     """
     The additional argument information.
     """
diff --git a/cmd/frontend/internal/dotcom/productsubscription/tokens_graphql.go b/cmd/frontend/internal/dotcom/productsubscription/tokens_graphql.go
index 140c5eb6152..b46c1b9ead0 100644
--- a/cmd/frontend/internal/dotcom/productsubscription/tokens_graphql.go
+++ b/cmd/frontend/internal/dotcom/productsubscription/tokens_graphql.go
@@ -5,8 +5,8 @@ import (
 	"fmt"
 
 	"github.com/sourcegraph/sourcegraph/cmd/frontend/graphqlbackend"
-	"github.com/sourcegraph/sourcegraph/internal/codygateway"
 	"github.com/sourcegraph/sourcegraph/internal/errcode"
+	internalproductsubscription "github.com/sourcegraph/sourcegraph/internal/productsubscription"
 )
 
 type ErrProductSubscriptionNotFound struct {
@@ -21,7 +21,7 @@ func (e ErrProductSubscriptionNotFound) Error() string {
 }
 
 func (e ErrProductSubscriptionNotFound) Extensions() map[string]any {
-	return map[string]any{"code": codygateway.GQLErrCodeProductSubscriptionNotFound}
+	return map[string]any{"code": internalproductsubscription.GQLErrCodeProductSubscriptionNotFound}
 }
 
 // ProductSubscriptionByAccessToken retrieves the subscription corresponding to the
diff --git a/cmd/frontend/internal/telemetry/resolvers/resolvers.go b/cmd/frontend/internal/telemetry/resolvers/resolvers.go
index adb77d840b2..c09c715d371 100644
--- a/cmd/frontend/internal/telemetry/resolvers/resolvers.go
+++ b/cmd/frontend/internal/telemetry/resolvers/resolvers.go
@@ -17,7 +17,7 @@ import (
 // Resolver is the GraphQL resolver of all things related to telemetry V2.
 type Resolver struct {
 	logger   log.Logger
-	teestore teestore.Store
+	teestore *teestore.Store
 }
 
 // New returns a new Resolver whose store uses the given database
diff --git a/cmd/telemetry-gateway/BUILD.bazel b/cmd/telemetry-gateway/BUILD.bazel
new file mode 100644
index 00000000000..1251d564824
--- /dev/null
+++ b/cmd/telemetry-gateway/BUILD.bazel
@@ -0,0 +1,72 @@
+load("@io_bazel_rules_go//go:def.bzl", "go_binary", "go_library")
+load("@rules_oci//oci:defs.bzl", "oci_image", "oci_push", "oci_tarball")
+load("@rules_pkg//:pkg.bzl", "pkg_tar")
+load("@container_structure_test//:defs.bzl", "container_structure_test")
+load("//dev:oci_defs.bzl", "image_repository")
+
+go_binary(
+    name = "telemetry-gateway",
+    embed = [":telemetry-gateway_lib"],
+    visibility = ["//visibility:public"],
+    x_defs = {
+        "github.com/sourcegraph/sourcegraph/internal/version.version": "{STABLE_VERSION}",
+        "github.com/sourcegraph/sourcegraph/internal/version.timestamp": "{VERSION_TIMESTAMP}",
+    },
+)
+
+pkg_tar(
+    name = "tar_telemetry-gateway",
+    srcs = [":telemetry-gateway"],
+)
+
+oci_image(
+    name = "image",
+    base = "@wolfi_base",
+    entrypoint = [
+        "/sbin/tini",
+        "--",
+        "/telemetry-gateway",
+    ],
+    tars = [":tar_telemetry-gateway"],
+    user = "sourcegraph",
+)
+
+oci_tarball(
+    name = "image_tarball",
+    image = ":image",
+    repo_tags = ["telemetry-gateway:candidate"],
+)
+
+container_structure_test(
+    name = "image_test",
+    timeout = "short",
+    configs = ["image_test.yaml"],
+    driver = "docker",
+    image = ":image",
+    tags = [
+        "exclusive",
+        "requires-network",
+    ],
+)
+
+oci_push(
+    name = "candidate_push",
+    image = ":image",
+    repository = image_repository("telemetry-gateway"),
+)
+
+go_library(
+    name = "telemetry-gateway_lib",
+    srcs = ["main.go"],
+    importpath = "github.com/sourcegraph/sourcegraph/cmd/telemetry-gateway",
+    visibility = ["//visibility:private"],
+    deps = [
+        "//cmd/telemetry-gateway/shared",
+        "//internal/conf",
+        "//internal/env",
+        "//internal/sanitycheck",
+        "//internal/service/svcmain",
+        "@com_github_getsentry_sentry_go//:sentry-go",
+        "@com_github_sourcegraph_log//:log",
+    ],
+)
diff --git a/cmd/telemetry-gateway/CODENOTIFY b/cmd/telemetry-gateway/CODENOTIFY
new file mode 100644
index 00000000000..ea1439f6cc7
--- /dev/null
+++ b/cmd/telemetry-gateway/CODENOTIFY
@@ -0,0 +1,3 @@
+# See https://github.com/sourcegraph/codenotify for documentation.
+
+**/* @core-services
diff --git a/cmd/telemetry-gateway/internal/diagnosticsserver/BUILD.bazel b/cmd/telemetry-gateway/internal/diagnosticsserver/BUILD.bazel
new file mode 100644
index 00000000000..7d0079b4112
--- /dev/null
+++ b/cmd/telemetry-gateway/internal/diagnosticsserver/BUILD.bazel
@@ -0,0 +1,14 @@
+load("@io_bazel_rules_go//go:def.bzl", "go_library")
+
+go_library(
+    name = "diagnosticsserver",
+    srcs = ["diagnosticsserver.go"],
+    importpath = "github.com/sourcegraph/sourcegraph/cmd/telemetry-gateway/internal/diagnosticsserver",
+    visibility = ["//cmd/telemetry-gateway:__subpackages__"],
+    deps = [
+        "//internal/authbearer",
+        "//internal/trace",
+        "//internal/version",
+        "@com_github_sourcegraph_log//:log",
+    ],
+)
diff --git a/cmd/telemetry-gateway/internal/diagnosticsserver/diagnosticsserver.go b/cmd/telemetry-gateway/internal/diagnosticsserver/diagnosticsserver.go
new file mode 100644
index 00000000000..9e36ba3cbf6
--- /dev/null
+++ b/cmd/telemetry-gateway/internal/diagnosticsserver/diagnosticsserver.go
@@ -0,0 +1,71 @@
+package diagnosticsserver
+
+import (
+	"context"
+	"encoding/json"
+	"net/http"
+
+	"github.com/sourcegraph/log"
+
+	"github.com/sourcegraph/sourcegraph/internal/authbearer"
+	"github.com/sourcegraph/sourcegraph/internal/trace"
+	"github.com/sourcegraph/sourcegraph/internal/version"
+)
+
+// NewDiagnosticsHandler creates a handler for diagnostic endpoints typically served
+// on "/-/..." paths. It should be placed before any authentication middleware, since
+// we do a simple auth on a static secret instead that is uniquely generated per
+// deployment.
+func NewDiagnosticsHandler(
+	baseLogger log.Logger,
+	secret string,
+	healthCheck func(context.Context) error,
+) http.Handler {
+	baseLogger = baseLogger.Scoped("diagnostics", "healthz checks")
+
+	hasValidSecret := func(w http.ResponseWriter, r *http.Request) (yes bool) {
+		token, err := authbearer.ExtractBearer(r.Header)
+		if err != nil {
+			w.WriteHeader(http.StatusBadRequest)
+			_ = json.NewEncoder(w).Encode(map[string]string{
+				"error": err.Error(),
+			})
+			return false
+		}
+
+		if token != secret {
+			w.WriteHeader(http.StatusUnauthorized)
+			return false
+		}
+		return true
+	}
+
+	mux := http.NewServeMux()
+
+	// For sanity-checking what's live. Intentionally doesn't require the
+	// secret for convenience, and it's a mostly harmless endpoint.
+	mux.HandleFunc("/-/version", func(w http.ResponseWriter, r *http.Request) {
+		w.WriteHeader(http.StatusOK)
+		_, _ = w.Write([]byte(version.Version()))
+	})
+
+	mux.HandleFunc("/-/healthz", func(w http.ResponseWriter, r *http.Request) {
+		logger := trace.Logger(r.Context(), baseLogger)
+		if !hasValidSecret(w, r) {
+			return
+		}
+
+		if err := healthCheck(r.Context()); err != nil {
+			logger.Error("check failed", log.Error(err))
+
+			w.WriteHeader(http.StatusInternalServerError)
+			_, _ = w.Write([]byte("healthz: " + err.Error()))
+			return
+		}
+
+		w.WriteHeader(http.StatusOK)
+		_, _ = w.Write([]byte("healthz: ok"))
+	})
+
+	return mux
+}
diff --git a/cmd/telemetry-gateway/internal/events/BUILD.bazel b/cmd/telemetry-gateway/internal/events/BUILD.bazel
new file mode 100644
index 00000000000..c8da9c59488
--- /dev/null
+++ b/cmd/telemetry-gateway/internal/events/BUILD.bazel
@@ -0,0 +1,15 @@
+load("@io_bazel_rules_go//go:def.bzl", "go_library")
+
+go_library(
+    name = "events",
+    srcs = ["events.go"],
+    importpath = "github.com/sourcegraph/sourcegraph/cmd/telemetry-gateway/internal/events",
+    visibility = ["//cmd/telemetry-gateway:__subpackages__"],
+    deps = [
+        "//internal/pubsub",
+        "//internal/telemetrygateway/v1:telemetrygateway",
+        "//lib/errors",
+        "@com_github_sourcegraph_conc//pool",
+        "@org_golang_google_protobuf//encoding/protojson",
+    ],
+)
diff --git a/cmd/telemetry-gateway/internal/events/events.go b/cmd/telemetry-gateway/internal/events/events.go
new file mode 100644
index 00000000000..20f544ff1e7
--- /dev/null
+++ b/cmd/telemetry-gateway/internal/events/events.go
@@ -0,0 +1,77 @@
+package events
+
+import (
+	"context"
+	"encoding/json"
+
+	"google.golang.org/protobuf/encoding/protojson"
+
+	"github.com/sourcegraph/conc/pool"
+
+	"github.com/sourcegraph/sourcegraph/internal/pubsub"
+	telemetrygatewayv1 "github.com/sourcegraph/sourcegraph/internal/telemetrygateway/v1"
+	"github.com/sourcegraph/sourcegraph/lib/errors"
+)
+
+type Publisher struct {
+	topic pubsub.TopicClient
+
+	metadataJSON json.RawMessage
+}
+
+func NewPublisherForStream(eventsTopic pubsub.TopicClient, metadata *telemetrygatewayv1.RecordEventsRequestMetadata) (*Publisher, error) {
+	metadataJSON, err := protojson.Marshal(metadata)
+	if err != nil {
+		return nil, errors.Wrap(err, "marshaling metadata")
+	}
+	return &Publisher{
+		topic:        eventsTopic,
+		metadataJSON: metadataJSON,
+	}, nil
+}
+
+type PublishEventResult struct {
+	// EventID is the ID of the event that was published.
+	EventID string
+	// PublishError, if non-nil, indicates an error occurred publishing the event.
+	PublishError error
+}
+
+func (p *Publisher) Publish(ctx context.Context, events []*telemetrygatewayv1.Event) []PublishEventResult {
+	wg := pool.NewWithResults[PublishEventResult]().
+		WithMaxGoroutines(100) // limit each batch to some degree
+
+	for _, event := range events {
+		doPublish := func(event *telemetrygatewayv1.Event) error {
+			eventJSON, err := protojson.Marshal(event)
+			if err != nil {
+				return errors.Wrap(err, "marshalling event")
+			}
+
+			// Join our raw JSON payloads into a single message
+			payload, err := json.Marshal(map[string]json.RawMessage{
+				"metadata": p.metadataJSON,
+				"event":    json.RawMessage(eventJSON),
+			})
+			if err != nil {
+				return errors.Wrap(err, "marshalling event payload")
+			}
+
+			// Publish a single message in each callback to manage concurrency
+			// ourselves, and
+			if err := p.topic.Publish(ctx, payload); err != nil {
+				return errors.Wrap(err, "publishing event")
+			}
+
+			return nil
+		}
+
+		wg.Go(func() PublishEventResult {
+			return PublishEventResult{
+				EventID:      event.GetId(),
+				PublishError: doPublish(event),
+			}
+		})
+	}
+	return wg.Wait()
+}
diff --git a/cmd/telemetry-gateway/internal/server/BUILD.bazel b/cmd/telemetry-gateway/internal/server/BUILD.bazel
new file mode 100644
index 00000000000..455fd3dc188
--- /dev/null
+++ b/cmd/telemetry-gateway/internal/server/BUILD.bazel
@@ -0,0 +1,39 @@
+load("//dev:go_defs.bzl", "go_test")
+load("@io_bazel_rules_go//go:def.bzl", "go_library")
+
+go_library(
+    name = "server",
+    srcs = [
+        "metrics.go",
+        "publish_events.go",
+        "server.go",
+    ],
+    importpath = "github.com/sourcegraph/sourcegraph/cmd/telemetry-gateway/internal/server",
+    visibility = ["//cmd/telemetry-gateway:__subpackages__"],
+    deps = [
+        "//cmd/telemetry-gateway/internal/events",
+        "//internal/licensing",
+        "//internal/pubsub",
+        "//internal/telemetrygateway/v1:telemetrygateway",
+        "//internal/trace",
+        "//lib/errors",
+        "@com_github_sourcegraph_log//:log",
+        "@io_opentelemetry_go_otel//:otel",
+        "@io_opentelemetry_go_otel//attribute",
+        "@io_opentelemetry_go_otel_metric//:metric",
+        "@io_opentelemetry_go_otel_trace//:trace",
+        "@org_golang_google_grpc//codes",
+        "@org_golang_google_grpc//status",
+    ],
+)
+
+go_test(
+    name = "server_test",
+    srcs = ["publish_events_test.go"],
+    embed = [":server"],
+    deps = [
+        "//cmd/telemetry-gateway/internal/events",
+        "@com_github_hexops_autogold_v2//:autogold",
+        "@com_github_stretchr_testify//assert",
+    ],
+)
diff --git a/cmd/telemetry-gateway/internal/server/metrics.go b/cmd/telemetry-gateway/internal/server/metrics.go
new file mode 100644
index 00000000000..bae16718ca7
--- /dev/null
+++ b/cmd/telemetry-gateway/internal/server/metrics.go
@@ -0,0 +1,46 @@
+package server
+
+import (
+	"go.opentelemetry.io/otel"
+	"go.opentelemetry.io/otel/metric"
+)
+
+var meter = otel.GetMeterProvider().Meter("cmd/telemetry-gateway/internal/server")
+
+type recordEventsMetrics struct {
+	// Record total event lengths of requests
+	totalLength metric.Int64Histogram
+	// Record per-payload metrics
+	payload recordEventsRequestPayloadMetrics
+}
+
+type recordEventsRequestPayloadMetrics struct {
+	// Record event length of individual payloads
+	length metric.Int64Histogram
+	// Count number of failedEvents
+	failedEvents metric.Int64Counter
+}
+
+func newRecordEventsMetrics() (m recordEventsMetrics, err error) {
+	m.totalLength, err = meter.Int64Histogram(
+		"telemetry-gateway.record_events.total_length",
+		metric.WithDescription("Total number of events in record_events requests"))
+	if err != nil {
+		return m, err
+	}
+
+	m.payload.length, err = meter.Int64Histogram(
+		"telemetry-gateway.record_events.payload_length",
+		metric.WithDescription("Number of events in indvidiual record_events request payloads"))
+	if err != nil {
+		return m, err
+	}
+	m.payload.failedEvents, err = meter.Int64Counter(
+		"telemetry-gateway.record_events.payload_failed_events_count",
+		metric.WithDescription("Number of events that failed to submit in indvidiual record_events request payloads"))
+	if err != nil {
+		return m, err
+	}
+
+	return m, err
+}
